/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreValuelistJsonbRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValuelistJsonb extends TableImpl<VCoreValuelistJsonbRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_valuelist_jsonb</code>
     */
    public static final VCoreValuelistJsonb V_CORE_VALUELIST_JSONB = new VCoreValuelistJsonb();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValuelistJsonbRecord> getRecordType() {
        return VCoreValuelistJsonbRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_valuelist_jsonb.jsonb_agg</code>.
     */
    public final TableField<VCoreValuelistJsonbRecord, JSONB> JSONB_AGG = createField(DSL.name("jsonb_agg"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_jsonb.list</code>.
     */
    public final TableField<VCoreValuelistJsonbRecord, Integer> LIST = createField(DSL.name("list"), SQLDataType.INTEGER, this, "");

    private VCoreValuelistJsonb(Name alias, Table<VCoreValuelistJsonbRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValuelistJsonb(Name alias, Table<VCoreValuelistJsonbRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_valuelist_jsonb" as  WITH x(key, value, list) AS (
                SELECT t_core_value.varvalue,
                   t_core_valueparam.param_key,
                   t_core_value.fk_value_valuelist
                  FROM (common_dd.t_core_value
                    LEFT JOIN common_dd.t_core_valueparam ON ((t_core_valueparam.fk_valueparam_value = t_core_value.pk_core_value)))
               )
        SELECT jsonb_agg(jsonb_build_object('key', x.key, 'value', t_core_translation_key.translation_key)) AS jsonb_agg,
           x.list
          FROM (x
            LEFT JOIN common_dd.t_core_translation_key ON ((t_core_translation_key.translation_key = x.value)))
         GROUP BY x.list;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_jsonb</code> table
     * reference
     */
    public VCoreValuelistJsonb(String alias) {
        this(DSL.name(alias), V_CORE_VALUELIST_JSONB);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_jsonb</code> table
     * reference
     */
    public VCoreValuelistJsonb(Name alias) {
        this(alias, V_CORE_VALUELIST_JSONB);
    }

    /**
     * Create a <code>common_dd.v_core_valuelist_jsonb</code> table reference
     */
    public VCoreValuelistJsonb() {
        this(DSL.name("v_core_valuelist_jsonb"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValuelistJsonb as(String alias) {
        return new VCoreValuelistJsonb(DSL.name(alias), this);
    }

    @Override
    public VCoreValuelistJsonb as(Name alias) {
        return new VCoreValuelistJsonb(alias, this);
    }

    @Override
    public VCoreValuelistJsonb as(Table<?> alias) {
        return new VCoreValuelistJsonb(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistJsonb rename(String name) {
        return new VCoreValuelistJsonb(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistJsonb rename(Name name) {
        return new VCoreValuelistJsonb(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistJsonb rename(Table<?> name) {
        return new VCoreValuelistJsonb(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonb where(Condition condition) {
        return new VCoreValuelistJsonb(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonb where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonb where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonb where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonb where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonb where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonb where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonb where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonb whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonb whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
